;=========================================================================
    include \masm32\include\masm32rt.inc
;=========================================================================

;-----------------------------------------------
; These are recycled from old DOS code, so Im
; not sure that everything is still valid.
;-----------------------------------------------

PARTENTRY STRUCT
  peBootable      db ?
  peBeginHead     db ?
  peBeginSector   db ?
  peBeginCylinder db ?
  peFileSystem    db ?
  peEndHead       db ?
  peEndSector     db ?
  peEndCylinder   db ?
  peStartSector   dd ?
  peSectors       dd ?
PARTENTRY ENDS

BOOTSECTOR STRUCT
  bsJump              db 3 dup(?)
  bsOemName           db 8 dup(?)
  ;---------------
  ; Start of BPB.
  ;---------------
  bsBytesPerSector    dw ?
  bsSectorsPerCluster db ?
  bsReservedSectors   dw ?
  bsFats              db ?
  bsRootDirEntries    dw ?
  bsSectors           dw ?
  bsMedia             db ?
  bsFatSectors        dw ?
  bsSectorsPerTrack   dw ?
  bsHeads             dw ?
  bsHiddenSectors     dd ?
  bsHugeSectors       dd ?
  ;------------
  ; End of BPB
  ;------------
  bsDriveNumber       db ?
  bsReserved          db ?
  bsBootSignature     db ?
  bsVolumeId          dd ?
  bsVolumeLabel       db 11 dup(?)
  bsFileSystemType    db 8 dup(?)
  ;----------------------------------------------------------
  ; The Microsoft documented BOOTSECTOR structure ends here.
  ; The filler and PARTENTRY members were added to adapt the
  ; structure to work for MBRs.
  ;----------------------------------------------------------
  filler              db 384 dup(?)
  pe1                 PARTENTRY <>
  pe2                 PARTENTRY <>
  pe3                 PARTENTRY <>
  pe4                 PARTENTRY <>
  signature           dw ?
BOOTSECTOR ENDS

;=========================================================================
.code
;=========================================================================

HexAsciiDump proc uses ebx esi edi address:DWORD,
                                   nparagraphs:DWORD,
                                   fZeroBase:DWORD

    mov esi, address
    mov ecx, nparagraphs
    test ecx, ecx
    jnz  rowLoop
    ret

    align 16

  hex_table:

    db "000102030405060708090A0B0C0D0E0F"
    db "101112131415161718191A1B1C1D1E1F"
    db "202122232425262728292A2B2C2D2E2F"
    db "303132333435363738393A3B3C3D3E3F"
    db "404142434445464748494A4B4C4D4E4F"
    db "505152535455565758595A5B5C5D5E5F"
    db "606162636465666768696A6B6C6D6E6F"
    db "707172737475767778797A7B7C7D7E7F"
    db "808182838485868788898A8B8C8D8E8F"
    db "909192939495969798999A9B9C9D9E9F"
    db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
    db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
    db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
    db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
    db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
    db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"

  ascii_table:

    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db " ","!",'"',"#","$","%","&","'","(",")","*","+",",","-",".","/"
    db "0","1","2","3","4","5","6","7","8","9",":",";","<","=",">","?"
    db "@","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O"
    db "P","Q","R","S","T","U","V","W","X","Y","Z","[","\","]","^","_"
    db "`","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o"
    db "p","q","r","s","t","u","v","w","x","y","z","{","|","}","~","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."
    db ".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","."

  rowLoop:

    push ecx

    .IF fZeroBase
      mov eax, esi
      sub eax, address
      print uhex$(eax)," "
    .ELSE                     ;
      print uhex$(esi)," "
    .ENDIF

    lea edi, hex_table
    push esi
    REPEAT 8
      print " "
      movzx ebx, BYTE PTR [esi]
      movzx eax, BYTE PTR [edi+ebx*2]
      invoke crt__putch, eax
      movzx eax, BYTE PTR [edi+ebx*2+1]
      invoke crt__putch, eax
      inc esi
    ENDM
    print " - "
    REPEAT 8
      movzx ebx, BYTE PTR [esi]
      movzx eax, BYTE PTR [edi+ebx*2]
      invoke crt__putch, eax
      movzx eax, BYTE PTR [edi+ebx*2+1]
      invoke crt__putch, eax
      print " "
      inc esi
    ENDM
    pop esi

    lea edi, ascii_table
    print "  "
    REPEAT 16
      movzx ebx, BYTE PTR [esi]
      movzx eax, BYTE PTR [edi+ebx]
      invoke crt__putch, eax
      inc esi
    ENDM
    print chr$(13,10)

    pop ecx
    dec ecx
    jnz rowLoop

    ret

HexAsciiDump endp

;=========================================================================
.data
    hDisk           dd 0
    bytesRead       dd 0
    bytesPerSector  dd 0
    buff            BOOTSECTOR <>
.code
;=========================================================================
start:
;=========================================================================

    invoke GetDiskFreeSpace, NULL,
                             ADDR bytesRead,
                             ADDR bytesPerSector,
                             ADDR bytesRead,
                             ADDR bytesRead
    .IF eax
        .IF bytesPerSector != 512
            print "Bytes per sector not 512",13,10
            inkey "Press any key to exit..."
            exit
        .ENDIF
    .ELSE
        print LastError$(),13,10
        inkey "Press any key to exit..."
        exit
    .ENDIF

    invoke CreateFile, chr$("\\.\PHYSICALDRIVE0"),
                       GENERIC_READ or GENERIC_WRITE,
                       FILE_SHARE_READ or FILE_SHARE_WRITE,
                       NULL,
                       OPEN_EXISTING,
                       0,
                       NULL

    .IF eax == INVALID_HANDLE_VALUE
        print LastError$(),13,10
        inkey "Press any key to exit..."
        exit
    .ELSE
        mov hDisk, eax
    .ENDIF

    ;----------------------------------------------------
    ; There is apparently no need for SetFilePointer or
    ; SetFilePointerEx when accessing the first sector.
    ;----------------------------------------------------

    ;-------------------------------------------------
    ; Read the MBR sector and display the number of
    ; bytes read and a hex-ascii dump of the sector.
    ;-------------------------------------------------

    invoke ReadFile, hDisk, ADDR buff, 512, ADDR bytesRead, NULL

    .IF eax == 0
        print LastError$(),13,10
        inkey "Press any key to exit..."
        exit
    .ENDIF

    print "Read "
    print ustr$(bytesRead), " bytes",13,10,13,10

    invoke HexAsciiDump, ADDR buff, 512/16, TRUE

    print chr$(13,10)

    ;-----------------------------------------------------
    ; If the first partition is bootable, locate and read
    ; the volume boot sector and display the number of
    ; bytes read and a hex-ascii dump of the sector.
    ;-----------------------------------------------------

    movzx eax, buff.pe1.peBootable
    .IF eax == 80h

        mov eax, buff.pe1.peStartSector
        shl eax, 9                      ; peStartSector * 512

        invoke SetFilePointer, hDisk,
                               eax,
                               NULL,
                               FILE_BEGIN

        .IF eax == INVALID_SET_FILE_POINTER
            print LastError$(),13,10
            inkey "Press any key to exit..."
            exit
        .ENDIF

        invoke ReadFile, hDisk, ADDR buff, 512, ADDR bytesRead, NULL

        .IF eax == 0
            print LastError$(),13,10
            inkey "Press any key to exit..."
            exit
        .ENDIF

        print "Read "
        print ustr$(bytesRead), " bytes",13,10,13,10

        invoke HexAsciiDump, ADDR buff, 512/16, TRUE

        print chr$(13,10)

    .ENDIF

    invoke CloseHandle, hDisk

    inkey "Press any key to exit..."
    exit

;=========================================================================
end start
